@echo off
setlocal ENABLEDELAYEDEXPANSION

rem DS203 Win32 GCC support by valky.eu
rem USER DEFINED VALUES
rem ===================================================
set CBASE=C:\Data\Work\ds203\compiler\arm-2011.03\bin\
set TARGET=F:\
set TFILE=APP_G251
set APP=4
rem ===================================================

set CROSS=!CBASE!arm-none-eabi-
set CC=!CROSS!gcc
set CPP=!CROSS!c++
set OBJCOPY=!CROSS!objcopy
set LD=!CROSS!ld
set AS=!CROSS!as
set STRIP=!CROSS!strip

if not exist !CC!.* (
  echo Compiler not found !
  goto :eof
)

set INTERMEDIATE=Bin

set STM_INC=../FWLib/inc
set STM_SRC=../FWLib/src
set STM_ASM=../FWLib/asm

set SRC_SRC=../App/src
set SRC_INC=../App/inc
set SRC_LDS=../App/lds
set SRC_ASM=../App/asm

set GFLAGS=-fno-exceptions -fno-rtti
set CFLAGS=-Wall -Os -Werror -fno-common -mcpu=cortex-m3 -mthumb -msoft-float -MD -I !STM_INC! -I !SRC_INC! -I !SRC_SRC!
set AFLAGS=-mcpu=cortex-m3 -mthumb
set LDFLAGS=-nostartfiles 

set OBJS=Interrupt.o Main.o Startup.o ^
         stm32f10x_nvic.o cortexm3_macro.o

set SRCS=!SRC_SRC!/Interrupt.c !SRC_SRC!/Startup.c ^
          !STM_SRC!/stm32f10x_nvic.c

set SRCS_CPP=!SRC_SRC!/Main.cpp

if not exist !INTERMEDIATE! mkdir !INTERMEDIATE!
cd !INTERMEDIATE!

if exist *.elf del *.elf
if exist *.hex del *.hex
if exist *.bin del *.bin
if exist *.c del *.c
if exist *.o del *.o

!CC! !AFLAGS! -c !STM_ASM!/cortexm3_macro.s -o cortexm3_macro.o
!CC! !AFLAGS! -c !SRC_ASM!/bios.S -o bios.o
!CPP! !CFLAGS! !GFLAGS! -c !SRCS_CPP!
!CC! !CFLAGS! -c !SRCS!
!CC! -o !TFILE!_!APP!.elf !LDFLAGS! -T !SRC_LDS!/app!APP!.lds !OBJS! 
!OBJCOPY! -O binary !TFILE!_!APP!.elf !TFILE!.bin
!OBJCOPY! -O ihex !TFILE!_!APP!.elf !TFILE!.hex

rem del *.d *.o

if not exist !TFILE!.hex (
  echo Build failed
  goto :eof
) else (
  echo Build succeed !
)

if not exist !TARGET! (
  echo Target device not ready
  goto :eof
)

if exist !TARGET!\*.WPT (
  echo Please start the device in DFU mode
  echo ^(Hold the first button while powering on^)
  goto :eof
)

Echo Downloading...
copy !TFILE!.hex !TARGET!!TFILE!.hex

Echo Waiting for the device...

rem Simple sleep
ping 127.0.0.1 -n 2 -w 500 > nul

if exist !TARGET!!TFILE!.hex (
  echo Device not ready
)

if exist !TARGET!!TFILE!.rdy (
  echo Download ok
) 

if exist !TARGET!!TFILE!.not (
  echo Failed to download
) 
